
CategoryQuickSlots = class( Turbine.UI.Control );

function CategoryQuickSlots:Constructor(language)
	Turbine.UI.Control.Constructor( self );

	self.slotRows = 2;
	self.slotColumns = 5;

	self:SetSize(36*self.slotColumns,36*self.slotRows);
	
	self.QuickSlot={};
	self.ItemSlot={};
	self.itemFitted={false,false,false,false,false};
	self.QuickSlotHighlighter={};
	self.colColor={};
	self.colColor[1]=Turbine.UI.Color(.5,0,.5);
	self.colColor[2]=Turbine.UI.Color(.5,0,0);
	self.colColor[3]=Turbine.UI.Color(.5,.5,0);
	self.colColor[4]=Turbine.UI.Color(0,.5,0);
	self.colColor[5]=Turbine.UI.Color(.5,.5,.5);
	local offsetX = 0;
	local offsetY = 0;
	for c = 1, self.slotColumns do
		for r = 1, self.slotRows do
			local i = (c-1) * self.slotRows + r;
			self.QuickSlot[i]=Turbine.UI.Lotro.Quickslot();
			self.QuickSlot[i]:SetParent(self);
			local x = offsetX + (c-1)*self.QuickSlot[i]:GetWidth();
			local y = offsetY + (r-1)*(self.QuickSlot[i]:GetHeight()-1);
			self.QuickSlot[i]:SetPosition(x,y);
			self.QuickSlot[i]:SetAllowDrop(true);
			self.QuickSlot[i]:SetZOrder(2);
			self.QuickSlot[i].ShortcutChanged = function(sender, args)
				if verbose >= 2 then
					Turbine.Shell.WriteLine("New shortcut data: "..self.QuickSlot[i]:GetShortcut():GetData());
				end
			end
			if r==1 then
				self.ItemSlot[c]=Turbine.UI.Lotro.ItemControl();
				self.ItemSlot[c]:SetParent(self);
				self.ItemSlot[c]:SetPosition(x,y);
				self.ItemSlot[c]:SetAllowDrop(true);
				self.ItemSlot[c]:SetZOrder(2);
				self.ItemSlot[c]:SetVisible(false);
			end
		end
		
		local itop = (c-1) * self.slotRows + 1;
		self.QuickSlotHighlighter[c]=Turbine.UI.Control();
		self.QuickSlotHighlighter[c]:SetParent(self);
		self.QuickSlotHighlighter[c]:SetPosition(self.QuickSlot[itop]:GetLeft()+2,self.QuickSlot[itop]:GetTop()+2);
		self.QuickSlotHighlighter[c]:SetSize(self.QuickSlot[itop]:GetWidth()-1,(self.QuickSlot[itop]:GetHeight()-1)*self.slotRows);
		self.QuickSlotHighlighter[c]:SetBackColor(self.colColor[c]);
		self.QuickSlotHighlighter[c]:SetZOrder(1);
	end
	
	-- Try To Fill Quick Slots
	local player = Turbine.Gameplay.LocalPlayer:GetInstance();
	local classNumber = player:GetClass();
	
	shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/"..Resource[language][51].." "..Resource[language][53].."!");
	self.QuickSlot[(1-1)*(self.slotRows)+2]:SetShortcut( shortcut );
	shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/"..Resource[language][51].." "..Resource[language][54].."!");
	self.QuickSlot[(2-1)*(self.slotRows)+2]:SetShortcut( shortcut );
	shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/"..Resource[language][51].." "..Resource[language][55].."!");
	self.QuickSlot[(3-1)*(self.slotRows)+2]:SetShortcut( shortcut );
	shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/"..Resource[language][51].." "..Resource[language][56].."!");
	self.QuickSlot[(4-1)*(self.slotRows)+2]:SetShortcut( shortcut );
	shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/"..Resource[language][51].." "..Resource[language][52].."!");
	self.QuickSlot[(5-1)*(self.slotRows)+2]:SetShortcut( shortcut );

	if Turbine.Gameplay.Class.Champion == classNumber then
		-- Self fear remover (Keine Furcht!)
		local shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, "0x70021D27");
		self.QuickSlot[(1-1)*(self.slotRows)+2]:SetShortcut( shortcut );
		-- Blutdurst
		shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, "0x7000F70E");
		self.QuickSlot[(5-1)*(self.slotRows)+1]:SetShortcut( shortcut );
	elseif Turbine.Gameplay.Class.LoreMaster == classNumber then
		local shortcut2 = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, "0x7001F45F"); -- below 62: 0x70003132
		self.QuickSlot[(2-1)*(self.slotRows)+2]:SetShortcut( shortcut2 );
--		local shortcut3 = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, "0x70003158"); 
--		self.QuickSlot[(3-1)*(self.slotRows)+2]:SetShortcut( shortcut3 );
	elseif Turbine.Gameplay.Class.Captain == classNumber then
		-- Mut fassen
		local shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, "0x70002F99");
		self.QuickSlot[(1-1)*(self.slotRows)+2]:SetShortcut( shortcut );
	elseif Turbine.Gameplay.Class.Hunter == classNumber then
		-- Gift neutralsieren
		local shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, "0x70003F3E");
		self.QuickSlot[(4-1)*(self.slotRows)+2]:SetShortcut( shortcut );
	elseif Turbine.Gameplay.Class.Minstrel == classNumber then
		-- Furcht heilen
		local shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, "0x70003E8B");
		self.QuickSlot[(1-1)*(self.slotRows)+2]:SetShortcut( shortcut );
	elseif Turbine.Gameplay.Class.Burglar == classNumber then
		-- Gift neutralsieren
		local shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, "0x7001F4A4");
		self.QuickSlot[(4-1)*(self.slotRows)+2]:SetShortcut( shortcut );
--	elseif Turbine.Gameplay.Class.RuneKeeper == classNumber then
--		-- Klinge verwundet nicht
--		local shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, "0x7000F2A1");
--		self.QuickSlot[(2-1)*(self.slotRows)+2]:SetShortcut( shortcut );
--		-- Fangzahn vergiftet nicht
--		local shortcut = Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, "0x7000F2A0");
--		self.QuickSlot[(4-1)*(self.slotRows)+2]:SetShortcut( shortcut );
	end
end

function CategoryQuickSlots:FitPotions()
	-- Try To Fill Quick Slots
	local player = Turbine.Gameplay.LocalPlayer:GetInstance();
	local backpack = player:GetBackpack();
	local backpackSize=backpack:GetSize();
	
	for i=1,backpackSize do
		local item = backpack:GetItem(i);
		if item~=nil and item:GetCategory()==Turbine.Gameplay.ItemCategory.Potion then
			for c=1,4 do
				if Resource[language][45+c]==item:GetName() then
					-- Put potion in slot at top row
					local j = (c-1) * self.slotRows + 1;
					self.QuickSlot[j]:SetVisible(false);
					self.ItemSlot[c]:SetVisible(true);
					self.ItemSlot[c]:SetItem(item);
					self.itemFitted[c]=true;
				end
			end
		end
	end
end

function CategoryQuickSlots:PotionsFitted()
	for c=1,4 do
		if not self.itemFitted[c] then
			return false;
		end
		local item = self.ItemSlot[c]:GetItem();
		if item==nil then
			return false;
		end
		if item:GetQuantity()<25 then
			return false;
		end
	end
	return true;
end

function CategoryQuickSlots:setVisible(flags)
	for c = 1, self.slotColumns do
		if c <= #flags then
			for r = 1, self.slotRows do
				local i = (c-1) * self.slotRows + r;
				if self.itemFitted[c] and r==1 then
					self.ItemSlot[c]:SetVisible(flags[c]);
				else
					self.QuickSlot[i]:SetVisible(flags[c]);
				end
			end
			self.QuickSlotHighlighter[c]:SetVisible(flags[c]);
		end
	end
end



